public class Quantization {


   private int[] QuantizedArray;

   private int[] UnQuantizedArray;

   private int[] QuantizedOperands;


   public Quantization() {


   }

   public int[] getUnquantizedValues(int[] QArray) {
 
      UnQuantizedArray = QArray;

      for(int x = 0; x < 64; x++) {

         UnQuantizedArray[x] = (int)(QuantizedArray[x] * QuantizedOperands[x] - 0.5);

      }

      return UnQuantizedArray;

   }


   public int[] getQuantizedValues(int[] QArray) {

      QuantizedArray = QArray;

      for(int x = 0; x < 64; x++) {

         QuantizedArray[x] = (int)(UnQuantizedArray[x] / QuantizedOperands[x] + 0.5);

      }

      return QuantizedArray;

   }


   public void setQuantizedOperands(int[] operands) {

      QuantizedOperands = operands;

   }

}