import java.io.*;

public class jpg {

///////////////////////////////////////////////////

   public static void main(String[] args) {

      new jpg(args[0]);

   }


//////////////////////////////////////////////////////


   public int[] YQuantizationTable = new int[64];

   public int[] CbCrQuantizationTable = new int[64];

   public int quantizeTableOccurency = 1;


//////////////////////////////////////////////////  HUFFMAN ;)



   private int[] BITS = new int[17];

   private int[] HUFFVAL = new int[256];

   private int[] HUFFSIZE = new int[257];

   private int[] HUFFCODE = new int[257];



//////////////////////////////////////////////////



   public jpg(String source) {


      try {


         File f = new File(source);

         FileInputStream fis = new FileInputStream(f);


            int a, b, c, d;

            int length1, length2, t_length;

            MarkerIdentifier mi = new MarkerIdentifier();

            String m;

            boolean CDMarker = false;


            fis.read();
            fis.read(); // SOI
         
            while((a = fis.read()) != -1) {


               if(a == 255) {

                  if((b = fis.read()) != 0) {

                     m = mi.getMarker(b);

                     System.out.print("\n" + m + " Marker Identified   " + a + "   " + b + "\n\n");

//////////////////////////////////////////////////////////////////////////////////////////////Quantization Table Marker


                     if(b == 219) {

                        length1 = fis.read() * 256;
                        length2 = fis.read();
                        t_length = length1 + length2;

                        fis.read();
System.out.println(t_length);
                        if(quantizeTableOccurency == 1) {

                           for(int x = 0; x < t_length-3; x++) { YQuantizationTable[x] = fis.read(); }

                        }

                        if(quantizeTableOccurency == 2) {

                           for(int x = 0; x < t_length-3; x++) { CbCrQuantizationTable[x] = fis.read(); }

                        }
 
                        if(quantizeTableOccurency == 1) { quantizeTableOccurency++; }

for(int x = 0; x < 64; x++) { System.out.print(YQuantizationTable[x]+ " "); }
System.out.println("\n\n\n");
for(int x = 0; x < 64; x++) { System.out.print(CbCrQuantizationTable[x]+ " "); }

                     }


////////////////////////////////////////////////////////////////////////////////////////////////Huffman Table Marker


                     else if( b == 196) {



                        length1 = fis.read() * 256;
                        length2 = fis.read();
                        t_length = length1 + length2;

                        fis.read();   // TC & TH

                        for(int x = 1; x < 17; x++) { BITS[x] = fis.read(); }

                        for(int x = 0; x < t_length-19; x++) { HUFFVAL[x] = fis.read(); }




///////////////////////////////////////////////////////////////////////////////////////////////////////////////////



System.out.println("\nBITS\n------\n");

for(int x = 1; x < 17; x++) {

System.out.print(BITS[x]+", ");

}

System.out.println("\n-----------------------\n");

////

System.out.println("\n\n\nHUFFVAL\n-------\n");

for(int x = 0; x < HUFFVAL.length; x++) {

System.out.print(HUFFVAL[x]+", ");

}

System.out.println("\n-----------------------\n");


////////////////////////////////////////////////////////////////////////////HUFFSIZE////


                     int K = 0;
                     int I = 1;
                     int J = 1;


                     while(I <= 16) {

                        if(J > BITS[I]) {
                           I++;
                           J = 1;
                        }

                        else {
                           HUFFSIZE[K] = I;
                           K++;
                           J++;
                        }

                     }

                     HUFFSIZE[K] = 0;



///////////////////////////////////////////////////////////////////////////////////////////


System.out.println("\nHUFFSIZE\n----------\n");

for(int x = 0; x < HUFFSIZE.length; x++) {

System.out.print(HUFFSIZE[x]+", ");

}

System.out.println("\n-----------------------\n");




///////////////////////////////////////////////////////////////////////////HUFFCODE////




                               K = 0;
                        int CODE = 0;
                        int SI   = HUFFSIZE[0];

                        while(true) {

                           HUFFCODE[K] = CODE;
                           CODE = CODE + 1;
                           K = K + 1;

                           if(HUFFSIZE[K] == SI) {

                           }

                           else {

                               if(HUFFSIZE[K] == 0) {

                                  break;

                               }

                               else {

                                  while(HUFFSIZE[K] != SI) {

                                     CODE = CODE << 1;
                                     SI = SI + 1;

                                  }

                               }

                           }


                        }



System.out.println("HUFFCODE\n-----------------");

for(int x = 0; x < HUFFCODE.length; x++) {

System.out.print(HUFFCODE[x]+", ");

}

System.out.println("\n------------------------------------\n");




////////////////////////////////////////////////////////////////////////////////////////




                     }


///////////////////////////////////////////////////////////////////////////////////////////////Start of Frame Marker


                     else if( b == 192) {

                        length1 = fis.read() * 256;
                        length2 = fis.read();
                        t_length = length1 + length2;

                        for(int x = 0; x < t_length-2; x++) { fis.read(); }


                     }


/////////////////////////////////////////////////////////////////////////////////////////////Start Of Scan Process


                     else if(b == 218) {

                        length1 = fis.read() * 256;
                        length2 = fis.read();
                        t_length = length1 + length2;

                        for(int x = 0; x < t_length-2; x++) { fis.read(); }

System.out.println("\nSTART OF IMAGE DATA\n");

                        while((c = fis.read()) != -1) { 

                           if(c == 255) {

                              if((d = fis.read()) != 0) {

                                 CDMarker = true;

                                 m = mi.getMarker(d);

                                 System.out.print("\n" + m + "\n");

                                 length1 = fis.read() * 256;
                                 length2 = fis.read();
                                 t_length = length1 + length2;

                                 for(int x = 0; x < t_length-2; x++) { System.out.print((char)fis.read()); }

                                 // Could Implement Code To Process Markers Inbetween Image Data If Any Exists

                              }

                              else {

                               //  System.out.print((char)c +""+ (char)d+"");

                              }

                           }


                              //  if(!CDMarker) { System.out.print((char)c+""); }

                        }

                     }





///////////////////////////////////////////////////////////////////////////////////////////////Ignored Marker

                     else {

                        length1 = fis.read() * 256;
                        length2 = fis.read();
                        t_length = length1 + length2;

                        for(int x = 0; x < t_length-2; x++) { fis.read(); }

                     }

////////////////////////////////////////////////////////////////////////////////////////////////////


                  }

               }


            }



         fis.close();

      } catch(Exception e) {

         System.out.println(e+"");

      }


   }

////////////////////////////////////////////////



}