import java.io.FileInputStream;
import java.io.IOException;


public class HuffmanTable {


   private int[] BITS = new int[17];

   private int[] HUFFVAL = new int[256];


   private int[] HUFFSIZE = new int[257];

   private int[] HUFFCODE = new int[257];




   public void fillHuffmanTable(FileInputStream fis) {

      try {

         int length1 = fis.read() * 256;
         int length2 = fis.read();
         int t_length = length1 + length2;

         fis.read();

         for(int x = 1; x < 17; x++) { BITS[x] = fis.read(); }

         HUFFVAL = new int[t_length-19];

         for(int x = 0; x < t_length-19; x++) { HUFFVAL[x] = fis.read(); }

         fillHUFFSIZE();

         fillHUFFCODE();

      } catch(IOException e) {}

   }




   private int K = 0;
   private int I = 1;
   private int J = 1;


   private void fillHUFFSIZE() {

      while(I <= 16) {

         if(J > BITS[I]) {
            I++;
            J = 1;
         }

         else {
            HUFFSIZE[K] = I;
            K++;
            J++;
         }

      }

      HUFFSIZE[K] = 0;

   }




   private void fillHUFFCODE() {

          K = 0;
      int CODE = 0;
      int SI   = HUFFSIZE[0];

      while(true) {

         HUFFCODE[K] = CODE;
         CODE = CODE + 1;
         K = K + 1;

         if(HUFFSIZE[K] == SI) {

                           }

         else {

            if(HUFFSIZE[K] == 0) {

               break;

            }

            else {

               while(HUFFSIZE[K] != SI) {

                  CODE = CODE << 1;
                  SI = SI + 1;

               }

            }

         }


      }



   }




   public void displayHUFFVAL() {

     System.out.print("\nHUFFVAL\n");

     for(int x = 0; x < 256; x++) {

        System.out.print(HUFFVAL[x] + ", ");

     }

     System.out.print("\n");

   }



   public void displayHUFFSIZE() {

     System.out.print("\nHUFFSIZE\n");

     for(int x = 0; x < 257; x++) {

        System.out.print(HUFFSIZE[x] + ", ");

     }

     System.out.print("\n");

   }


   public void displayHUFFCODE() {

     System.out.print("\nHUFFCODE\n");

     for(int x = 0; x < 257; x++) {

        System.out.print(HUFFCODE[x] + ", ");

     }

     System.out.print("\n");

   }



   public void displayBITS() {

     System.out.print("\nBITS\n");

     for(int x = 1; x < 17; x++) {

        System.out.print(BITS[x] + ", ");

     }

     System.out.print("\n");

   }





}