
public class TransformColorSpace {

   private int R, G, B, Y, Cb, Cr;

   public TransformColorSpace() {


   }

   public ThreeByte getRGB(int Y, int Cb, int Cr) {

      R = (int)(Y + 1.402 * (Cr - 128));

      G = (int)(Y - 0.34414 * (Cb - 128) - 0.71414 * (Cr - 128));

      B = (int)(Y + 1.722 * (Cb-128));

      return new ThreeByte(R, G, B);

   }


   public ThreeByte getYCbCr(int R, int G, int B) {

      Y = (int)(0.299 * R + 0.587 * G + 0.114 * B);

      Cb = (int)(- 0.1687 * R - 0.3313 * G + 0.5 * B + 128);

      Cr = (int)(0.5 * R - 0.4187 * G - 0.0813 * B + 128);

      return new ThreeByte(Y, Cb, Cr);

   }

}