import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;



public class JPG {

   public static void main(String[] args) {

      new JPG(args[0]);

   }



   private QuantizationTables QTS = new QuantizationTables();


   private HuffmanTable HT1 = new HuffmanTable();

   private HuffmanTable HT2 = new HuffmanTable();

   private HuffmanTable HT3 = new HuffmanTable();

   private HuffmanTable HT4 = new HuffmanTable();


   private int QTOccurence = 0;

   private int HTOccurence = 0;



   public JPG(String filename) {

      try {

         File jpg = new File(filename);

         FileInputStream fis = new FileInputStream(jpg);

         int a, b;

            fis.read();
            fis.read();  // SQI

         while((a = fis.read()) != -1) {

            if(a == 255) {

               if((b = fis.read()) != 0) {

                  System.out.println("Marker Identified:  " + a + "  " + b);

                  if(b == 219) {

                     QTS.fillQuantizationTables(fis);

                     QTS.displayTables();

                  }

                  else if(b == 196) {

                     HTOccurence++;

                     if(HTOccurence == 1) { HT1.fillHuffmanTable(fis); }
                     if(HTOccurence == 2) { HT2.fillHuffmanTable(fis); }
                     if(HTOccurence == 3) { HT3.fillHuffmanTable(fis); }
                     if(HTOccurence == 4) { HT4.fillHuffmanTable(fis); }




                  }

                  else if(b == 218) {

                     SCAN(fis);

                  }


                  else {

                     skipMarker(fis);

                  }

               }

            }

         }

      } catch(IOException e) {}


   }





   private void SCAN(FileInputStream fis) {

      try {

         int a, b;

         while((a = fis.read()) != -1) {

            System.out.print((char)a);

            if(a == 255) {

               if((b = fis.read()) != 0) {

                //  System.out.println("MARKER INBETWEEN IMAGE DATA");

               }

               else {

               //   System.out.print((char)b);

               }

            }

         }

      } catch(IOException e) {}


   }




   private void skipMarker(FileInputStream fis) {

      try {

         int length1 = fis.read() * 256;
         int length2 = fis.read();
         int t_length = length1 + length2;

         fis.skip(t_length-2);

      } catch(IOException e) {}

   }




}








