import java.io.FileInputStream;
import java.io.IOException;

  
public class QuantizationTables {


   public int[] YQuantizationTable = new int[64];

   public int[] CbCrQuantizationTable = new int[64];



   public void fillQuantizationTables(FileInputStream fis) {   // this reads in the two quantization tables to two int[] arrays

      try {

         int length1 = fis.read() * 256;
         int length2 = fis.read();
         int t_length = length1 + length2;


            fis.read();  // precision

            for(int x = 0; x < 64; x++) { 

               YQuantizationTable[x] = fis.read();

            }

            fis.read(); // precision

            for(int x = 0; x < 64; x++) { 

               CbCrQuantizationTable[x] = fis.read();

            }



      } catch(IOException e) {}

   }


   public void displayTables() {

      System.out.print("\nQuantization Tables\n");

      for(int x = 0; x < 64; x++) {

         System.out.print(YQuantizationTable[x] + ", ");

      }

      System.out.print("\n");

      for(int x = 0; x < 64; x++) {

         System.out.print(CbCrQuantizationTable[x] + ", ");

      }

      System.out.print("\n");

   }


}